<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransactionDataMin ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTransactionDataMin
 * @subpackage Arrays
 */
class ArrayOfTransactionDataMin extends AbstractStructArrayBase
{
    /**
     * The TransactionDataMin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\TransactionDataMin[]
     */
    public $TransactionDataMin;
    /**
     * Constructor method for ArrayOfTransactionDataMin
     * @uses ArrayOfTransactionDataMin::setTransactionDataMin()
     * @param \patest\StructType\TransactionDataMin[] $transactionDataMin
     */
    public function __construct(array $transactionDataMin = array())
    {
        $this
            ->setTransactionDataMin($transactionDataMin);
    }
    /**
     * Get TransactionDataMin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\TransactionDataMin[]|null
     */
    public function getTransactionDataMin()
    {
        return isset($this->TransactionDataMin) ? $this->TransactionDataMin : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransactionDataMin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransactionDataMin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransactionDataMinForArrayConstraintsFromSetTransactionDataMin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTransactionDataMinTransactionDataMinItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransactionDataMinTransactionDataMinItem instanceof \patest\StructType\TransactionDataMin) {
                $invalidValues[] = is_object($arrayOfTransactionDataMinTransactionDataMinItem) ? get_class($arrayOfTransactionDataMinTransactionDataMinItem) : sprintf('%s(%s)', gettype($arrayOfTransactionDataMinTransactionDataMinItem), var_export($arrayOfTransactionDataMinTransactionDataMinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransactionDataMin property can only contain items of type \patest\StructType\TransactionDataMin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransactionDataMin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\TransactionDataMin[] $transactionDataMin
     * @return \patest\ArrayType\ArrayOfTransactionDataMin
     */
    public function setTransactionDataMin(array $transactionDataMin = array())
    {
        // validation for constraint: array
        if ('' !== ($transactionDataMinArrayErrorMessage = self::validateTransactionDataMinForArrayConstraintsFromSetTransactionDataMin($transactionDataMin))) {
            throw new \InvalidArgumentException($transactionDataMinArrayErrorMessage, __LINE__);
        }
        if (is_null($transactionDataMin) || (is_array($transactionDataMin) && empty($transactionDataMin))) {
            unset($this->TransactionDataMin);
        } else {
            $this->TransactionDataMin = $transactionDataMin;
        }
        return $this;
    }
    /**
     * Add item to TransactionDataMin value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\TransactionDataMin $item
     * @return \patest\ArrayType\ArrayOfTransactionDataMin
     */
    public function addToTransactionDataMin(\patest\StructType\TransactionDataMin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\TransactionDataMin) {
            throw new \InvalidArgumentException(sprintf('The TransactionDataMin property can only contain items of type \patest\StructType\TransactionDataMin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransactionDataMin[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\TransactionDataMin|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\TransactionDataMin|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\TransactionDataMin|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\TransactionDataMin|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\TransactionDataMin|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransactionDataMin
     */
    public function getAttributeName()
    {
        return 'TransactionDataMin';
    }
}
